/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

int Check_conditions (int trt_data_Tag)
{

   if (trt_data_Tag == 0)
   {
      printf ("Error: No Trait Data Supplied, Exiting...\n");
      return 0;
   }

   if ((nStatType != 0) && (bNormalEnable))
   {
      printf
         ("Error: Normal Test cannot be performed for Test Statistic other than Mean, Exiting...\n");
      return 0;
   }
   if (((bRobdomOn + bNewStatOn + bSpairsOn + blambdaOn) > 0)
       && (nChiSquareEnable))
   {
      printf
         ("Error: Chi-square Test cannot be performed with IBD measures, Exiting...\n");
      return 0;
   }
   if (((bLikelihoodOn + bDeltaOn) > 0)
       && ((bNormalEnable) || (bPermutationEnable)))
   {
      printf
         ("Error: Permutation Test/ Normality-based Test cannot be performed with likelihood-ratios, Exiting...\n");
      return 0;
   }

   if ((bPermutationEnable == 1) && (nNumOfIter == 0))
   {
      printf
         ("Error: Can not calculate p Value without sampling, Exiting...\n");
      return 0;
   }
   if (((bPermutationEnable == 1)) && (nNumOfIter < 1))
   {
      printf
         ("Error: Specify more permutations to get sensible p-value, Exiting...\n");
      return 0;
   }

   if (((bPermutationEnable == 0)) && (nNumOfIter == 0))
   {
      if ((bNormalEnable == 0) && (nChiSquareEnable == 0))
      {
         printf ("Error: No Test Specified, Exiting...\n");
         return 0;
      }

   }
   if (((bPermutationEnable == 0)) && (nNumOfIter > 0))
   {
      if ((bNormalEnable == 0) && (nChiSquareEnable == 0))
      {
         printf ("Error: No Test Specified, Exiting...\n");
         return 0;
      }
      else
      {
         printf ("Warning: You don't need to do permutation Here\n");
         nNumOfIter = 1;

      }
   }
   if ((bNewStatOn) && (bNormalEnable))
   {
      printf ("You cannot calculate Saffunaff for Test for Normality..EXIT\n");
      return 0;
   }

   if ((bPermutationEnable))
   {
      nNumOfIter = nNumOfIter + 1;
   }
   return 1;
}
