/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
#include  <math.h>
#define PI  3.1472
#define CORR 0.02
#define Nul_Hyp 0

/********  Variables for  Permutation  of affectation status *************/
int   trt_data_Tag = 0;
int  *tot_affected = NULL;
int  *tot_unaffected = NULL;
int  *Total_Size = NULL;
int  *trt_data = NULL;
int  *trt_obs = NULL;
double *Param_Val_Array = NULL;
double **Val_Array = NULL;
double ***newstat = NULL;/*** S_{aff-Unaff} **/
double ***robdomstat = NULL;/*** S_{rob dom}  ***/
double ***spairs = NULL;/*** S_{pairs}  ****/
double ***newstat_Lambda = NULL;        /* IBD measure S_{lambda}$ */
double *paff = NULL;
/***********variables for test under normality *******************/
double ***Statistic = NULL;
double **Mean_Val = NULL;
double **Variance_Val = NULL;
double Weight = 0;
double *base = NULL;
int **exint = NULL;
int **exint1 = NULL;
/* Variables for likelihood-based test **********/
double *****likelihood_chi = NULL;
int  *n_founders = NULL;
double *minval_chi = NULL;
founder **founder_allele = NULL;
double *maxval_chi = NULL;
double *delta_Max_chi = NULL;
/**** Delta Method *******/
double value_S = 0;
double *nullmean = NULL;
double *nullvariance = NULL;
double *nullmeandelta_chi = NULL;
double *nullvariancedelta_chi = NULL;
double **Stat_chi = NULL;
double *likestat = NULL;
int  *store_index = NULL;
double **deltaStat = NULL;
double *delta_Val = NULL;
double null_delta_like = 0;
int **aff_array = NULL;
int **unaff_array = NULL;
int **trait_array = NULL;
double **Covariance = NULL;
double **Variance1 = NULL;
double **Variance2 = NULL;

void initialize_variables (int SEG_LAMBDA, int nloc) /* Function for initializing variables for lm_ibdtests */
{

   int   c, locus, i, tagval, tot_count;

   if ((bLikelihoodOn) || (bDeltaOn))
   {

      trt_data = (int *) calloc (pedsize, sizeof (int));
      alloc_chk (WHERE, trt_data);
      trt_obs = (int *) calloc (pedsize, sizeof (int));
      alloc_chk (WHERE, trt_obs);

      for (i = 0; i < pedsize; i++)
      {
         if (nghd[i].d_dat != NULL)
         {
            trt_obs[i] = nghd[i].d_dat[0];
         }
         else
            trt_obs[i] = 0;
      }
   }

   if (blambdaOn)
   {
      Param_Val_Array = (double *) calloc (SEG_LAMBDA + 1, sizeof (double));
      alloc_chk (WHERE, Param_Val_Array);
      paff = (double *) calloc (pedsize, sizeof (double));
      alloc_chk (WHERE, paff);
   }

   if (bNormalEnable)
   {
      Statistic = (double ***) calloc (n_compnts, sizeof (double **));
      alloc_chk (WHERE, Statistic);
      for (c = 0; c < n_compnts; c++)
      {
         Statistic[c] = (double **) calloc (nloc + 1, sizeof (double *));
         alloc_chk (WHERE, Statistic[c]);
         for (locus = 0; locus <= nloc; locus++)
         {
            int   nNumOfStatInd =
               bRobdomOn + bNewStatOn + blambdaOn + bSpairsOn;
            Statistic[c][locus] =
               (double *) calloc (nNumOfStatInd, sizeof (double));
            alloc_chk (WHERE, Statistic[c][locus]);
         }
      }
   }

   if (bPermutationEnable)
   {

      tot_affected = (int *) calloc (n_compnts, sizeof (int));
      alloc_chk (WHERE, tot_affected);

      tot_unaffected = (int *) calloc (n_compnts, sizeof (int));
      alloc_chk (WHERE, tot_unaffected);

      Total_Size = (int *) calloc (n_compnts, sizeof (int));
      alloc_chk (WHERE, Total_Size);
      exint = (int **) calloc (n_compnts, sizeof (int *));
      alloc_chk (WHERE, exint);
      if (bNewStatOn)
      {
         exint1 = (int **) calloc (n_compnts, sizeof (int *));
         alloc_chk (WHERE, exint1);
      }
      tot_count = 0;
      for (c = 0; c < n_compnts; c++)
      {
         for (i = 0; i < Group[c]; i++)
         {
            tot_affected[c] = tot_affected[c] + size_aff[c][i];
            tot_unaffected[c] = tot_unaffected[c] + size_unaff[c][i];
            Total_Size[c] = Total_Size[c] + Size[c][i];
         }
      }

      for (c = 0; c < n_compnts; c++)
      {
         exint[c] = (int *) calloc ((Total_Size[c] + 2), sizeof (int));
         alloc_chk (WHERE, exint[c]);
         if (bNewStatOn)
         {
            exint1[c] =
               (int *) calloc ((2 * Group[c] + Total_Size[c] + 1),
                               sizeof (int));
            alloc_chk (WHERE, exint1[c]);
         }
      }
      if (bNewStatOn)
      {
         for (c = 0; c < n_compnts; c++)
         {
            exint1[c][0] = Group[c];
            for (i = 0; i < Group[c]; i++)
            {
               exint1[c][i + 1] = size_aff[c][i];
            }

            for (i = 0; i < Group[c]; i++)
            {
               exint1[c][Group[c] + i + 1] = size_unaff[c][i];
            }
         }
      }

   }
   if (bRobdomOn)
   {
      robdomstat = alloc_3_dim_array (n_compnts, nNumOfIter, nloc + 1);
      alloc_chk (WHERE, robdomstat);
      base = (double *) calloc (2, sizeof (double));
      alloc_chk (WHERE, base);

   }
   if (blambdaOn)
   {
      newstat_Lambda = alloc_3_dim_array (n_compnts, nNumOfIter, nloc + 1);
      alloc_chk (WHERE, newstat_Lambda);

   }
   if (bNewStatOn)
   {
      newstat = alloc_3_dim_array (n_compnts, nNumOfIter, nloc + 1);
      alloc_chk (WHERE, newstat);

   }
   if (bSpairsOn)
   {
      spairs = alloc_3_dim_array (n_compnts, nNumOfIter, nloc + 1);
      alloc_chk (WHERE, spairs);

   }

   if ((bNormalEnable))
   {
      tagval = bNewStatOn + bSpairsOn + bRobdomOn + blambdaOn;
      Mean_Val = (double **) calloc (n_compnts, sizeof (double *));
      alloc_chk (WHERE, Mean_Val);
      Variance_Val = (double **) calloc (n_compnts, sizeof (double *));
      alloc_chk (WHERE, Variance_Val);
      for (c = 0; c < n_compnts; c++)
      {
         Mean_Val[c] = (double *) calloc (tagval, sizeof (double));
         alloc_chk (WHERE, Mean_Val[c]);
         Variance_Val[c] = (double *) calloc (tagval, sizeof (double));
         alloc_chk (WHERE, Variance_Val[c]);

      }
   }

   if (blambdaOn)
   {
      Val_Array = (double **) calloc (n_compnts, sizeof (double *));
      alloc_chk (WHERE, Val_Array);
      for (c = 0; c < n_compnts; c++)
      {
         Val_Array[c] =
            (double *) calloc ((pedsize + SEG_LAMBDA + 2), sizeof (double));
         alloc_chk (WHERE, Val_Array);
      }
   }

   if ((nChiSquareEnable) && (bLikelihoodOn))
   {
      likelihood_chi =
         alloc_5_dim_array (n_compnts, nloc + 1, nNumOfSegl, nNumOfSegl,
                            nNumOfSegp);
      alloc_chk (WHERE, likelihood_chi);
      likestat = (double *) calloc (nloc + 1, sizeof (double));
      alloc_chk (WHERE, likestat);
      store_index = (int *) calloc (nloc + 1, sizeof (int));
      alloc_chk (WHERE, store_index);
      Covariance = (double **) calloc (nloc + 1, sizeof (double *));
      alloc_chk (WHERE, Covariance);
      Variance1 = (double **) calloc (nloc + 1, sizeof (double *));
      alloc_chk (WHERE, Variance1);
      Variance2 = (double **) calloc (nloc + 1, sizeof (double *));
      alloc_chk (WHERE, Variance2);
      for (locus = 0; locus <= nloc; locus++)
      {
         Covariance[locus] = (double *) calloc (nNumOfSegp, sizeof (double));
         alloc_chk (WHERE, Covariance[locus]);
         Variance1[locus] = (double *) calloc (nNumOfSegp, sizeof (double));
         alloc_chk (WHERE, Variance1[locus]);
         Variance2[locus] = (double *) calloc (nNumOfSegp, sizeof (double));
         alloc_chk (WHERE, Variance2[locus]);
      }
      n_founders = (int *) calloc (n_compnts, sizeof (int));
      alloc_chk (WHERE, n_founders);

      for (c = 0; c < n_compnts; c++)
      {
         for (i = 0; i < pedsize; i++)
         {
            if (nghd[i].component == (c + 1))
            {
   /** Calculate number of founders per component **/
               if ((nghd[i].pa == &nullnode) && (nghd[i].ma == &nullnode))
                  n_founders[c] = n_founders[c] + 1;
            }
         }
      }

      founder_allele = (founder **) calloc (n_compnts, sizeof (founder *));
      alloc_chk (WHERE, founder_allele);
      for (c = 0; c < n_compnts; c++)
      {

         founder_allele[c] =
            (founder *) calloc (2 * n_founders[c], sizeof (founder));
         alloc_chk (WHERE, founder_allele[c]);

      }

   }

   if ((nChiSquareEnable) && (bDeltaOn))
   {

      nullmeandelta_chi = (double *) calloc (n_compnts, sizeof (double));
      alloc_chk (WHERE, nullmeandelta_chi);
      nullvariancedelta_chi = (double *) calloc (n_compnts, sizeof (double));
      alloc_chk (WHERE, nullvariancedelta_chi);
      minval_chi = (double *) calloc (n_compnts, sizeof (double));
      alloc_chk (WHERE, minval_chi);
      maxval_chi = (double *) calloc (n_compnts, sizeof (double));
      alloc_chk (WHERE, maxval_chi);
      Stat_chi = alloc_double_matry (n_compnts, nloc + 1);
      alloc_chk (WHERE, Stat_chi);
      delta_Val = (double *) calloc (nloc + 1, sizeof (double));
      alloc_chk (WHERE, delta_Val);
      delta_Max_chi = (double *) calloc (nloc + 1, sizeof (double));
      alloc_chk (WHERE, delta_Max_chi);

      for (i = 0; i < n_compnts; i++)
      {

         minval_chi[i] = 10000;

         maxval_chi[i] = 0;

      }
   }

}

void initialize_score (Measure ** score_aff) /* Function to assign the IBD measures that will be used in lm_ibdtests */
{
   Measure *pMeasure = NULL;
   int   num_ibd = 0;
   pMeasure =
      (Measure *) calloc ((bSpairsOn + bRobdomOn + bNewStatOn + blambdaOn),
                          sizeof (Measure));
   alloc_chk (WHERE, pMeasure);

   if (bSpairsOn)
   {
      pMeasure[num_ibd] = spair;
      num_ibd = num_ibd + 1;
   }
   if (bRobdomOn)
   {
      pMeasure[num_ibd] = robdom;
      num_ibd = num_ibd + 1;
   }
   if (bNewStatOn)
   {
      *score_aff[num_ibd] = Saffunaff;
      num_ibd = num_ibd + 1;
   }
   if (blambdaOn)
   {
      pMeasure[num_ibd] = Calculate_Likelihood_Lambda;
      num_ibd = num_ibd + 1;
   }
   *score_aff = pMeasure;

}

void initialize_valarray (double *paff, int SEG_LAMBDA) /* Function to assign values to exreal[] for Slambda and assign values to exint[] for Srobdom */
{
   int   i, c;
   Param_Val_Array[0] = (double) SEG_LAMBDA;
   for (i = 1; i <= SEG_LAMBDA; i++)
   {
      Param_Val_Array[i] = (double) ((double) i / 10.0);
   }

   for (c = 0; c < n_compnts; c++)
   {
      Val_Array[c][0] = (double) bPermutationEnable;
      for (i = 0; i < pedsize; i++)
      {
         Val_Array[c][i + 1] = paff[i];
      }
      for (i = 0; i <= SEG_LAMBDA; i++)
      {
         Val_Array[c][(pedsize) + 1 + i] = Param_Val_Array[i];
      }
   }
   if (bRobdomOn)
   {
      base[0] = 0;
      base[1] = 7;
   }

}

void Calculate_Stat (int nsw)           /* Function to calculate the mean and variance of different allele-sharing statistics for normality-based test */
{
   int   t, c;
   if (bDeltaOn)
   {
      for (c = 0; c < n_compnts; c++)
      {
         nullmeandelta_chi[c] = 0;
         nullvariancedelta_chi[c] = 0;
      }
   }
   for (t = 0; t < NIt; ++t)
   {

      realize_null (0, nsw);
      /* set the genes         */
      set_FGL (0);

      /* score the ibd measure -- store the value (NIt values!!) */
      for (c = 0; c < n_compnts; c++)
      {
         int   Count = 0;
         if (bSpairsOn)
         {
            double Value_S = 0;
            double Indicator = 0;
            Value_S = spair (c, 0, 0, &Indicator);
            Mean_Val[c][Count] = Mean_Val[c][Count] + Value_S;

            Variance_Val[c][Count] = Variance_Val[c][Count] + Value_S * Value_S;
            Count = Count + 1;
         }

         if (bRobdomOn)
         {
            double Value_S = 0;
            base[0] = 0;
            base[1] = 7;
            Value_S = robdom (c, 0, 0, base);
            Mean_Val[c][Count] = Mean_Val[c][Count] + Value_S;
            Variance_Val[c][Count] = Variance_Val[c][Count] + Value_S * Value_S;
            Count = Count + 1;
         }
         if (blambdaOn)
         {
            double like = 0;
            like = Calculate_Likelihood_Lambda (c, 0, 0, Val_Array[c]);
            Mean_Val[c][Count] = Mean_Val[c][Count] + like;
            Variance_Val[c][Count] = Variance_Val[c][Count] + like * like;

            Count = Count + 1;
         }

         if (bDeltaOn)
         {
            double value_S = 0;
            double Indicator = 0;
            value_S = spair (c, 0, 0, &Indicator);
            nullmeandelta_chi[c] = nullmeandelta_chi[c] + value_S;
            nullvariancedelta_chi[c] =
               nullvariancedelta_chi[c] + value_S * value_S;
            if (value_S < minval_chi[c])
            {
               minval_chi[c] = value_S;
            }
            if (value_S > maxval_chi[c])
            {
               maxval_chi[c] = value_S;
            }

         }

      }
   }
}

void reset_measurevars (int nloc)       /* Function to initialize IBD measures */
{
   int   c, i, j;
   for (c = 0; c < n_compnts; c++)
   {
      for (i = 0; i < nNumOfIter; i++)
      {
         for (j = 0; j < (nloc + 1); j++)
         {
            if (bRobdomOn)
            {
               robdomstat[c][i][j] = 0;
            }
            if ((bNewStatOn))
            {
               newstat[c][i][j] = 0;
            }
            if (bSpairsOn)
            {
               spairs[c][i][j] = 0;
            }
            if (blambdaOn)
            {
               newstat_Lambda[c][i][j] = 0;
            }
         }
      }
   }
}

void assign_values (int c, int locus)   /* Function to compute the allele-sharing statistics for normality-based test */
{
   int   Count = 0;
   if (bNewStatOn)
   {
      printf ("You cannot calculate Saffunaff for Test for Normality\n");
      bNewStatOn = 0;
   }
   if (bSpairsOn)
   {
      double Value_S = 0;
      double Indicator = 0;
      Value_S = spair (c, locus, 0, &Indicator);
      Statistic[c][locus][Count] = Statistic[c][locus][Count] + Value_S;

      Count = Count + 1;
   }
   if (bRobdomOn)
   {
      double Value_S = 0;
      base[0] = 0;
      Value_S = robdom (c, locus, 0, base);
      Statistic[c][locus][Count] = Statistic[c][locus][Count] + Value_S;

      Count = Count + 1;

   }
   if (blambdaOn)
   {
      double like = 0;

      like = Calculate_Likelihood_Lambda (c, locus, 0, Val_Array[c]);
      Statistic[c][locus][Count] = Statistic[c][locus][Count] + like;

      Count = Count + 1;

   }
}

void reassign_values (int c, int iter1, int locus) /* Function to compute the allele-sharing statistics for permutation test */
{
   if (bNewStatOn)
   {
      newstat[c][iter1][locus] =
         newstat[c][iter1][locus] + Saffunaff (c, locus, exint1[c], 0);
   }
   if (bSpairsOn)
   {
      double value_S = 0;
      double Indicator = 1.0;
      value_S = spair (c, locus, exint[c], &Indicator);
      spairs[c][iter1][locus] = spairs[c][iter1][locus] + value_S;

   }

   if (bRobdomOn)
   {

      base[0] = 1;
      robdomstat[c][iter1][locus] =
         robdomstat[c][iter1][locus] + robdom (c, locus, exint[c], base);

   }

   if (blambdaOn)
   {
      double like = 0;
      like = Calculate_Likelihood_Lambda (c, locus, exint[c], Val_Array[c]);
      newstat_Lambda[c][iter1][locus] = newstat_Lambda[c][iter1][locus] + like;

   }
}

void file_write (int Total_Sampling, int nloc) /* Function to write the IBD measures from each MCMC scan in a file */
{
   FILE *write_fp = NULL;
   int   len = 0;
   char  buffer[256];
   int   c, iter1, locus;
   len = sprintf (buffer, "%s/file_%d", pStrTempDir, Total_Sampling);

   write_fp = open_chkq (WHERE, buffer, "w+");

   for (iter1 = 0; iter1 < nNumOfIter; iter1++)
   {
      for (locus = 1; locus < (nloc + 1); locus++)
      {
         if (bNewStatOn)
         {
            double newstat_val = 0;
            for (c = 0; c < n_compnts; c++)
            {
               newstat_val = newstat_val + newstat[c][iter1][locus];
            }
            len = sprintf (buffer, "%lf\n", newstat_val);
            fwrite (buffer, 1, len, write_fp);

         }
         if (bSpairsOn)
         {
            double spair_val = 0;
            for (c = 0; c < n_compnts; c++)
            {
               spair_val = spair_val + spairs[c][iter1][locus];
            }
            len = sprintf (buffer, "%lf\n", spair_val);
            fwrite (buffer, 1, len, write_fp);

         }
         if (bRobdomOn)
         {
            double rob_val = 0;
            for (c = 0; c < n_compnts; c++)
            {
               rob_val = rob_val + robdomstat[c][iter1][locus];
            }

            len = sprintf (buffer, "%lf\n", rob_val);
            fwrite (buffer, 1, len, write_fp);
         }
         if (blambdaOn)
         {
            double lambda_val = 0;
            for (c = 0; c < n_compnts; c++)
            {
               lambda_val = lambda_val + newstat_Lambda[c][iter1][locus];
            }

            len = sprintf (buffer, "%lf\n", lambda_val);
            fwrite (buffer, 1, len, write_fp);
         }
      }
   }

   fclose (write_fp);
}

void printMatry ()
{
    /*** prints all permutations*******/
#if 0
   int   c, v, v1;
   for (c = 0; c < n_compnts; c++)
   {
      printf ("Permutation for component %d\n", c);
      for (v = 0; v < nNumOfIter; v++)
      {
         for (v1 = 0; v1 < nTotalSize; v1++)
         {
            printf ("%d ", matry[c][v][v1]);
         }
         printf ("(%d)\n", v);
      }
      printf ("(%d)\n", c);
   }
#endif
}

/*****************************************************************************************/

void Max_Delta (int nloc, int Total_Sampling) /* Function to maximize the likelihood under delta Model */
{

   double minval_final = 1000;
   double maxval_final = 0;
   int   c, locus;
   for (c = 0; c < n_compnts; c++)
   {

      nullmeandelta_chi[c] = (double) (nullmeandelta_chi[c] / NIt);
      nullvariancedelta_chi[c] =
         (double) (nullvariancedelta_chi[c] / NIt) -
         (double) (nullmeandelta_chi[c] * nullmeandelta_chi[c]);

      if (nullvariancedelta_chi[c] > 0)
      {
         minval_chi[c] =
            (double) (sqrt (nullvariancedelta_chi[c]) /
                      (nullmeandelta_chi[c] - minval_chi[c]));
         maxval_chi[c] =
            (double) ((sqrt (nullvariancedelta_chi[c]) /
                       (maxval_chi[c] - nullmeandelta_chi[c])));

      }
      else
      {

         minval_chi[c] = 1000;
         maxval_chi[c] = 0;

      }

   }

   for (locus = 0; locus < (nloc + 1); locus++)
   {
      double delta = 0;
      double OldVal = -999;
      minval_final = 1000;
      maxval_final = 0;
      delta_Val[locus] = 0;
      for (c = 0; c < n_compnts; c++)
      {

         if ((minval_chi[c] < minval_final) && (minval_chi[c] > 0))
         {
            minval_final = minval_chi[c];

         }
         if ((maxval_chi[c] > maxval_final) && (minval_chi[c] > 0))
         {
            maxval_final = maxval_chi[c];
         }

      }

      /*  minval_final= minval_final * (double)(sqrt((double)n_compnts));
         printf("minval-finall %lf\n", minval_final); */
      while ((delta <= (double) (minval_final)))
      {
         double Stat2 = 0;
         for (c = 0; c < n_compnts; c++)
         {
            double Stat1 = 0;
            if (nullvariancedelta_chi[c] > 0)
            {

               Stat1 =
                  ((double)
                   ((Stat_chi[c][locus] / Total_Sampling) -
                    nullmeandelta_chi[c]) / sqrt (nullvariancedelta_chi[c]));

               Stat2 = Stat2 + log ((double) (1.0 + delta * Stat1));

            }

         }

         if ((OldVal < Stat2))
         {
            OldVal = Stat2;
            delta_Max_chi[locus] = delta;
         }
         delta = delta + .01;
      }

      delta_Val[locus] = 2 * (OldVal);

   }
}

void Max_lambdap (int nloc, int Total_Sampling, double SEG_L_INTERVAL, double SEG_P_INTERVAL) /* Function to maximize the likelihood under (lambda,p) model */
{
   double lambda_aff_final, p_final, lambda_unaff_final, Old_Value,
      likelihood_value, null_like;
   int   c, locus, v, v1, v2;

   for (locus = 0; locus < (nloc + 1); locus++)
   {

      Old_Value = -999;
      for (v = 0; v < nNumOfSegl; v++)
      {
         for (v2 = 0; v2 < nNumOfSegl; v2++)
         {
            for (v1 = 0; v1 < nNumOfSegp; v1++)
            {
               likelihood_value = 0;

               for (c = 0; c < n_compnts; c++)
               {
                  likelihood_value =
                     likelihood_value +
                     log ((double)
                          (likelihood_chi[c][locus][v][v2][v1] /
                           Total_Sampling));
                  if ((locus == 0) && (v1 == 0) && (v == 5) && (v2 == 5))
                  {
                     null_like =
                        null_like +
                        log ((double)
                             (likelihood_chi[c][locus][v][v2][v1] /
                              Total_Sampling));
                     /* printf("I am at line %d %lf\n",__LINE__,null_like); */

                  }
               }

               if (likelihood_value > Old_Value)
               {
                  Old_Value = likelihood_value;
                  lambda_aff_final = 1.0 - SEG_L_INTERVAL * v;
                  lambda_unaff_final = 0.0 + SEG_L_INTERVAL * v2;
                  p_final = .1 + SEG_P_INTERVAL * v1;
                  store_index[locus] = v1;
               }
            }
         }
      }

      likestat[locus] = 2 * (Old_Value - null_like);

   }

}
void Likelambdap_Computation (int c, int nloc, double SEG_L_INTERVAL, double SEG_P_INTERVAL) /* Function to compute the likelihood under (lambda,p) model */
{
   int   locus, v1, v2, v;
   double p, lambda_aff, lambda_unaff;
   p = 0.1;
   lambda_aff = 1.0;
   lambda_unaff = 0.0;
   v1 = 0;
   while (p <= .9)
   {
      v = 0;
      lambda_aff = 1.0;
      while ((lambda_aff >= .5))
      {
         lambda_unaff = 0.0;
         v2 = 0;
         while ((lambda_unaff <= .5))
         {
            for (locus = 0; locus <= nloc; locus++)
            {

               likelihood_chi[c][locus][v][v2][v1] =
                  likelihood_chi[c][locus][v][v2][v1] + Calculate_Likelihood (c,
                                                                              n_founders
                                                                              [c],
                                                                              trt_obs,
                                                                              locus,
                                                                              p,
                                                                              lambda_aff,
                                                                              lambda_unaff,
                                                                              v1);

            }

            lambda_unaff = lambda_unaff + SEG_L_INTERVAL;
            v2 = v2 + 1;
         }
         lambda_aff = lambda_aff - SEG_L_INTERVAL;
         v = v + 1;
      }
      p = p + SEG_P_INTERVAL;
      v1 = v1 + 1;
   }
}

void Likedelta_Computation (int c, int nloc) /* Function to compute the likelihood under delta model */
{
   int   locus;

   for (locus = 0; locus <= nloc; locus++)
   {
      double value_S = 0;
      double Indicator = 0;
      value_S = spair (c, locus, 0, &Indicator);
      Stat_chi[c][locus] = Stat_chi[c][locus] + value_S;
   }
}

double Corr_Computation ()              /* Function to compute the correlation under (lambda,p) model */
{
   double correlation = 0;
   int   locus = 1;

   double X = (double) sqrt ((double) (Variance1[locus][store_index[locus]]));

   double Y1 = (double) sqrt ((double) (Variance2[locus][store_index[locus]]));

   if ((Variance1[locus][store_index[locus]] == 0)
       || (Variance2[locus][store_index[locus]] == 0))
   {
      correlation = 0;
   }
   else
   {
      correlation =
         -(double) ((Covariance[locus][store_index[locus]]) /
                    ((double) (X * Y1)));
   }
   printf ("Correlation %lf for %d locus\n", correlation, locus);

   return correlation;
}

void pVal_Computation (int nloc)        /* Function to compute the p-value under (lambda,p) model */
{
   double ValueA, ValueB;
   double final_p_like = 0, correlation = 0;
   double final_p_delta = 0;
   int   locus;
   if (bLikelihoodOn)
   {
      if ((Nul_Hyp))
      {
         correlation = Corr_Computation ();
      }
      else
      {
         correlation = CORR;
      }
      ValueA = (double) (1 / (double) (2.0 * PI)) * (acos (correlation));

      ValueB = (double) (1 / (double) (2.0 * PI)) * (PI - acos (correlation));
   }
   printf ("*****************************\n");
   printf ("p Value for Chi-Square Test\n");
   printf ("*****************************\n");
   printf ("Locus\t");
   if (bLikelihoodOn)
   {
      printf ("LR(lambda,p)   pvalue\t");
   }
   if (bDeltaOn)
   {
      printf ("hat(Delta)\t LR(Delta)\t pvalue\t");
   }
   printf ("\n");
   for (locus = 1; locus <= nloc; locus++)
   {

      if (bLikelihoodOn)
      {

         final_p_like = cdfLR (likestat[locus], ValueA, ValueB);

      }
      if (bDeltaOn)
      {

         final_p_delta = .5 * cdfdelta (delta_Val[locus]);
      }

      printf ("%d\t", locus);

      if (bLikelihoodOn)
      {
         printf ("%lf\t %lf\t", likestat[locus], final_p_like);
      }
      if (bDeltaOn)
      {
         printf ("%lf\t %lf\t%lf\t", delta_Max_chi[locus], delta_Val[locus],
                 final_p_delta);
      }
      printf ("\n");
   }

}

void Norm_Compute (int nloc, int Total_Sampling) /* Function to compute the p-value under normality-based test */
{
   int   i, j, c;
   double q_norm;
   for (i = 1; i <= (nloc); i++)
   {
      int   bnewtag, bspairtag, brobtag, blambdatag;
      int   nNoOfStatOfInts = bSpairsOn + bNewStatOn + bRobdomOn + blambdaOn;
      bnewtag = bNewStatOn;
      bspairtag = bSpairsOn;
      brobtag = bRobdomOn;
      blambdatag = blambdaOn;
      for (j = 0; j < nNoOfStatOfInts; j++)
      {
         double Stat_Val = 0;
         Weight = 0;
         if (i == 1)
         {

            for (c = 0; c < n_compnts; c++)
            {

               Mean_Val[c][j] = (double) (Mean_Val[c][j] / NIt);
               Variance_Val[c][j] =
                  (double) ((Variance_Val[c][j]) / NIt) -
                  (Mean_Val[c][j] * Mean_Val[c][j]);
               /* printf("%lf=mean %lf= variance\n",  Mean_Val[c][j], Variance_Val[c][j]); */
            }
         }

         if ((i == 1) && (j == 0))
         {
            printf ("*****************************\n");
            printf ("p Value under Normality Test\n");
            printf ("*****************************\n");
            printf ("Locus\t");
            if (bNewStatOn)
            {
               printf ("Saffunaff  pvalue\t");
            }
            if (bSpairsOn)
            {
               printf ("Spairs  pvalue\t");
            }
            if (bRobdomOn)
            {
               printf ("Srobdom  pvalue\t");
            }
            if (blambdaOn)
            {
               printf ("Slambda  pvalue\t");
            }
            printf ("\n");
            printf ("********************************\n");
         }

         Stat_Val = 0;

         for (c = 0; c < n_compnts; c++)
         {
            if (Variance_Val[c][j] > 0)
            {
               Weight = Weight + 1;
            }
         }
         /*    printf("Weight= %lf\n",Weight); */
         for (c = 0; c < n_compnts; c++)
         {

            if (Variance_Val[c][j] > 0)
            {
               /*  printf("Value for locus %d is %lf\n",i+1,Statistic[c][i][j]/Total_Sampling); */
               Stat_Val =
                  Stat_Val +
                  (double) (((double) (Statistic[c][i][j] / Total_Sampling) -
                             Mean_Val[c][j]) / sqrt (Variance_Val[c][j]));
            }
         }
         Stat_Val = ((double) (1 / sqrt ((double) Weight))) * Stat_Val;

         q_norm = 0;
         q_norm = normcdf (Stat_Val);
         if ((j == 0))
         {
            printf ("%d\t", i);
         }
         if (bnewtag)
         {
            printf ("%lf  %lf\t", Stat_Val, q_norm);
            bnewtag = 0;
         }

         else if (bspairtag)
         {
            printf ("%lf  %lf\t", Stat_Val, q_norm);
            bspairtag = 0;
         }
         else if (brobtag)
         {
            printf ("%lf  %lf\t", Stat_Val, q_norm);
            brobtag = 0;
         }
         else if (blambdatag)
         {
            printf ("%lf  %lf\t", Stat_Val, q_norm);
            blambdatag = 0;
         }
         if (j == (nNoOfStatOfInts - 1))
         {
            printf ("\n");
         }

      }
   }
   printf ("********************************\n");
   if (Mean_Val)
   {
      for (c = 0; c < n_compnts; c++)
      {
         if (Mean_Val[c])
            free (Mean_Val[c]);
      }
      free (Mean_Val);
   }

   if (Variance_Val)
   {
      for (c = 0; c < n_compnts; c++)
      {
         if (Variance_Val[c])
            free (Variance_Val[c]);
      }

      free (Variance_Val);
   }
   if (Statistic)
   {
      for (c = 0; c < n_compnts; c++)
      {
         if (Statistic[c])
         {
            for (j = 0; j < (nloc + 1); j++)
            {
               if (Statistic[c][j])
               {
                  free (Statistic[c][j]);
               }
            }
            free (Statistic[c]);
         }
      }
      free (Statistic);
   }

}

void free_memory (int nloc)             /* free memory * */
{
   free_int_matry (size_aff, n_compnts);
   free_int_matry (size_unaff, n_compnts);
   free_int_matry (Size, n_compnts);

   if (Group)
   {
      free (Group);
   }
   if (tot_affected)
   {
      free (tot_affected);
   }
   if (tot_unaffected)
   {
      free (tot_unaffected);
   }

   if (Total_Size != NULL)
   {
      free (Total_Size);
   }
   if (trt_data)
   {
      free (trt_data);
   }
   free_3_dim_double_array (robdomstat, n_compnts, nNumOfIter);
   free_3_dim_double_array (newstat, n_compnts, nNumOfIter);
   free_3_dim_double_array (spairs, n_compnts, nNumOfIter);
   free_3_dim_double_array (newstat_Lambda, n_compnts, nNumOfIter);
   free_int_matry (Affect_resimulation, nNumOfIter);

   if (n_founders != NULL)
   {
      free (n_founders);
   }

   free_3_dim_int_array (matry, n_compnts, nNumOfIter);

   if (pQuantileList != NULL)
   {
      free (pQuantileList);
   }
   if (nullmean != NULL)
   {
      free (nullmean);
   }
   if (nullvariance != NULL)
   {
      free (nullvariance);
   }

   if (paff)
      free (paff);
   if (Val_Array)
      free (Val_Array);
   if (Param_Val_Array)
      free (Param_Val_Array);

}

void Formatting ()
{
   printf ("Locus\t");

   if (bNewStatOn)
   {
      printf ("Saffunaff(p value)\t");
   }
   if (bSpairsOn)
   {
      printf ("Spairs(p value)\t");
   }
   if (bRobdomOn)
   {
      printf ("Srobdom(p value)\t");
   }
   if (blambdaOn)
   {
      printf ("Slambda(p value)\t");
   }
   printf ("\n");
   printf ("************************************\n");
}

void assign_exint (int **ex_ar, int **ex_ar1, int iter1, int c)/** assigning values to exint[] for permutation test ***/
{

   int   countv = 0;
   int  *ex_array = *ex_ar;
   int  *ex_array1 = *ex_ar1;
   ex_array[0] = tot_affected[c];
   ex_array[1] = Total_Size[c] - tot_affected[c];
   while (countv < tot_affected[c])
   {
      ex_array[countv + 2] = matry[c][iter1][countv];
      if (bNewStatOn)
         ex_array1[(2 * Group[c] + 1) + countv + 2] = matry[c][iter1][countv];
      countv = countv + 1;
   }
   while (countv < Total_Size[c])
   {
      ex_array[countv + 2] = matry[c][iter1][countv];
      if (bNewStatOn)
         ex_array1[(2 * Group[c] + 1) + countv + 2] = matry[c][iter1][countv];
      countv = countv + 1;
   }
}
