/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
#include <stdio.h>
#include <stdlib.h>

void  free_int_matry (int **matrix, int dim1);
void  free_double_matry (double **matrix, int dim1);
/*
double ******alloc_likelihood (int nNoComp, int nNoIter, int nNoLocus, int nNumSegl, int nNoSegp);
void  free_fileptrs (FILE **** fillptrs, int dim1, int dim2, int dim3, int nNoLocus, int nNumStat);
void  free_liklihood (double ******likelihood, int dim1, int dim2, int dim3, int dim4, int dim5, int nNoIter, int nNoLocus, int nNumSegl);
*/

FILE ****alloc_files (int nNoIter, int nNoLocus, int nNumStat);
double **alloc_double_matry (int row, int col);
void  free_3_dim_double_array (double ***matrix, int dim1, int dim2);
void  free_3_dim_int_array (int ***matrix, int dim1, int dim2);
double ***alloc_3_dim_array (int dim1, int dim2, int dim3);
double *****alloc_5_dim_array (int dim1, int dim2, int dim3, int dim4,
                               int dim5);

void  free_6_dim_array (double ******likelihood, int dim1, int dim2, int dim3,
                        int dim4, int dim5);
void  free_3_dim_fileptrs (FILE **** matrix, int dim1, int dim2);

double ******alloc_likelihood (int nNoComp, int nNoIter, int nNoLocus,
                               int nNumSegl, int nNoSegp)
{
   int   c, i, j, j1, k;
   double ******likelihood = NULL;
   likelihood = (double ******) calloc (nNoComp, sizeof (double *****));
   alloc_chk (WHERE, likelihood);

   for (c = 0; c < nNoComp; c++)
   {
      likelihood[c] = (double *****) calloc (nNoIter, sizeof (double ****));
      alloc_chk (WHERE, likelihood[c]);

      for (i = 0; i < nNoIter; i++)
      {
         likelihood[c][i] =
            (double ****) calloc (nNoLocus, sizeof (double ***));
         alloc_chk (WHERE, likelihood[c][i]);

         for (j = 0; j < nNoLocus; j++)
         {
            likelihood[c][i][j] =
               (double ***) calloc (nNumSegl, sizeof (double **));
            alloc_chk (WHERE, likelihood[c][i][j]);

            for (j1 = 0; j1 < nNumSegl; j1++)
            {
               likelihood[c][i][j][j1] =
                  (double **) calloc (nNumSegl, sizeof (double *));
               alloc_chk (WHERE, likelihood[c][i][j][j1]);

               for (k = 0; k < nNumSegl; k++)
               {

                  likelihood[c][i][j][j1][k] =
                     (double *) calloc (nNoSegp, sizeof (double));
                  alloc_chk (WHERE, likelihood[c][i][j][j1][k]);

               }
            }
         }
      }
   }
   return likelihood;
}

void free_6_dim_array (double ******likelihood, int dim1, int dim2, int dim3,
                       int dim4, int dim5)
{
   int   i, j, k, l, m;
   if (likelihood != NULL)
   {
      for (i = 0; i < dim1; i++)
      {
         if (likelihood[i] != NULL)
         {
            for (j = 0; j < dim2; j++)
            {
               if (likelihood[i][j] != NULL)
               {
                  for (k = 0; k < dim3; k++)
                  {
                     if (likelihood[i][j][k] != NULL)
                     {
                        for (l = 0; l < dim4; l++)
                        {
                           if (likelihood[i][j][k][l] != NULL)
                           {
                              for (m = 0; m < dim5; m++)
                              {
                                 if (likelihood[i][j][k][l][m] != NULL)
                                 {
                                    free (likelihood[i][j][k][l][m]);
                                 }
                              }
                              free (likelihood[i][j][k][l]);
                           }
                        }
                        free (likelihood[i][j][k]);
                     }
                  }
                  free (likelihood[i][j]);
               }
            }
            free (likelihood[i]);
         }
      }
      free (likelihood);
   }
}

void free_int_matry (int **matrix, int dim1)
{
   int   i;
   if (matrix == NULL)
      return;
   for (i = 0; i < dim1; i++)
   {
      if (matrix[i])
         free (matrix[i]);
   }
   if (matrix)
   {
      free (matrix);
   }
}

void free_double_matry (double **matrix, int dim1)
{
   int   i;
   if (matrix == NULL)
      return;
   for (i = 0; i < dim1; i++)
   {
      if (matrix[i])
         free (matrix[i]);
   }
   if (matrix)
   {
      free (matrix);
   }
}

FILE ****alloc_files (int dim1, int dim2, int dim3)
{
   FILE ****fp_local = NULL;
   int   i, j;
   if ((dim1 == 0) || (dim2 == 0) || (dim3 == 0))
      return NULL;
   fp_local = (FILE ****) calloc (dim1, sizeof (FILE ***));
   alloc_chk (WHERE, fp_local);

   for (i = 0; i < dim1; i++)
   {
      fp_local[i] = (FILE ***) calloc (dim2, sizeof (FILE **));
      alloc_chk (WHERE, fp_local[i]);

      for (j = 0; j < dim2; j++)
      {
         fp_local[i][j] = (FILE **) calloc (dim3, sizeof (FILE *));
         alloc_chk (WHERE, fp_local[i][j]);
      }
   }
   return fp_local;
}

double **alloc_double_matry (int row, int col)
{
   double **matrix = NULL;
   int   i;
   if ((row == 0) || (col == 0))
      return NULL;

   matrix = (double **) calloc (row, sizeof (double *));
   alloc_chk (WHERE, matrix);

   for (i = 0; i < row; i++)
   {
      matrix[i] = (double *) calloc (col, sizeof (double));
      alloc_chk (WHERE, matrix[i]);
   }
   return matrix;
}

void free_3_dim_fileptrs (FILE **** matrix, int dim1, int dim2)
{
   int   j, k;
   if (matrix != NULL)
   {
      for (j = 0; j < dim1; j++)
      {
         if (matrix[j] != NULL)
         {
            for (k = 0; k < dim2; k++)
            {
               if (matrix[j][k])
               {
                  free (matrix[j][k]);
               }
            }
            free (matrix[j]);
         }
      }
      free (matrix);
   }
}

void free_3_dim_double_array (double ***matrix, int dim1, int dim2)
{
   int   j, k;
   if (matrix != NULL)
   {
      for (j = 0; j < dim1; j++)
      {
         if (matrix[j] != NULL)
         {
            for (k = 0; k < dim2; k++)
            {
               if (matrix[j][k])
               {
                  free (matrix[j][k]);
               }
            }
            free (matrix[j]);
         }
      }
      free (matrix);
   }
}
void free_3_dim_int_array (int ***matrix, int dim1, int dim2)
{
   int   j, k;
   if (matrix != NULL)
   {
      for (j = 0; j < dim1; j++)
      {
         if (matrix[j] != NULL)
         {
            for (k = 0; k < dim2; k++)
            {
               if (matrix[j][k])
               {
                  free (matrix[j][k]);
               }
            }
            free (matrix[j]);
         }
      }
      free (matrix);
   }
}
double ***alloc_3_dim_array (int dim1, int dim2, int dim3)
{
   double ***matrix = NULL;
   int   i, j;
   if ((dim1 == 0) || (dim2 == 0) || (dim3 == 0))
      return NULL;
   matrix = (double ***) calloc (dim1, sizeof (double **));
   alloc_chk (WHERE, matrix);

   for (i = 0; i < dim1; i++)
   {
      matrix[i] = (double **) calloc (dim2, sizeof (double *));
      alloc_chk (WHERE, matrix[i]);

      for (j = 0; j < dim2; j++)
      {
         matrix[i][j] = (double *) calloc (dim3, sizeof (double));
         alloc_chk (WHERE, matrix[i][j]);
      }
   }
   return matrix;
}
double *****alloc_5_dim_array (int dim1, int dim2, int dim3, int dim4, int dim5)
{
   double *****matrix = NULL;
   int   i, j, k, l;
   if ((dim1 == 0) || (dim2 == 0) || (dim3 == 0) || (dim4 == 0) || (dim5 == 0))
      return NULL;
   matrix = (double *****) calloc (dim1, sizeof (double ****));
   alloc_chk (WHERE, matrix);

   for (i = 0; i < dim1; i++)
   {
      matrix[i] = (double ****) calloc (dim2, sizeof (double ***));
      alloc_chk (WHERE, matrix[i]);

      for (j = 0; j < dim2; j++)
      {
         matrix[i][j] = (double ***) calloc (dim3, sizeof (double **));
         alloc_chk (WHERE, matrix[i][j]);
         for (k = 0; k < dim3; k++)
         {
            matrix[i][j][k] = (double **) calloc (dim4, sizeof (double *));
            alloc_chk (WHERE, matrix[i][j][k]);
            for (l = 0; l < dim4; l++)
            {
               matrix[i][j][k][l] = (double *) calloc (dim5, sizeof (double));
               alloc_chk (WHERE, matrix[i][j][k][l]);
            }
         }
      }
   }

   return matrix;
}
