/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
#ifndef _READ_CONFIG_FILE_
#define _READ_CONFIG_FILE_

/************************************************************
| readConfigFile() : read the config parameters from file  **
************************************************************/
#define MAX_FILE_PATH    256

enum STAT_TYPE { STAT_MEAN,STAT_ANDERSON,STAT_QUANTILE} ;

int readConfigFile(char* fileName) ;
void printConfigParams();

int nNumOfLocus ;
int nNumOfIter ;
int nNumOfGroup ;
int nNumOfStat ;
int nNumOfAff ;
int nTotalSize ;
int nNumOfSegl ;
int nNumOfSegp ;
int nAutoChkPts ;
int nInterval ;
int bSpairsOn = 0;
int bLikelihoodOn = 0;
int bDeltaOn = 0;
int bRobdomOn = 0;
int bNewStatOn = 0;
int blambdaOn  =0;
char pStrOutputFile[MAX_FILE_PATH];
char pStrTempDir[MAX_FILE_PATH] ;
char pStrPermDir[MAX_FILE_PATH] ;

int bPermutationEnable = 0;
int bResimuEnable = 0;
int bNormalEnable = 0;
int nChiSquareEnable = 0 ;

int nStatType = STAT_MEAN ;
double* pQuantileList = NULL ;


#endif /* _READ_CONFIG_FILE_ */
