/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

/*    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                  */
void normalize_pseudo_prior (double *pseudo_prior_calc)
/*   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                  */
     /* Normalize and invert the pseudo-prior.                                  */
{
   int   ii;
   double nc;                           /* normalizing constant */

   /* calc. normalizing constant                                              */
   nc = 0.0;
   for (ii = 0; ii < NTPos1; ii++)
      nc += pseudo_prior_calc[ii];
   for (ii = 0; ii < NTPos1; ii++)
   {
      pseudo_prior_calc[ii] = pseudo_prior_calc[ii] / nc;
   }
   /* Take reciprocal probs: i.e. more weight placed on less 
      likely test positions                                                   */
   for (ii = 0; ii < NTPos1; ii++)
      pseudo_prior_calc[ii] = 1.0 / pseudo_prior_calc[ii];
   /* Renormalize */
   nc = 0.0;
   for (ii = 0; ii < NTPos1; ii++)
      nc += pseudo_prior_calc[ii];
   for (ii = 0; ii < NTPos1; ii++)
      pseudo_prior_calc[ii] = pseudo_prior_calc[ii] / nc;

   return;
}
