/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
#include "traits.h"

/**
 * Setup structures for recombination, inheritance indicators, genes,
 * and loci
 */
void setMaps (int nh)
{
   int   sx;
   int   trtloc0[3] = { 0, 0, 0 };
   double trtrec0[3] = { .5, .5, .5 };

   /* allocate and set arrays of marker and trait positions 
    * and recombination fractions  (for sampler setup, trait is unlinked).  
    *                                        int chromo[nh+1][NMarks+1]    
    *                                        revchro[nh+1][NMarks+1]      
    *                                        double xecomo[2][nh+1][NMarks+1] */
   alloc_chromo (NMarks, nh);

   /* Lodscore programs have test positions for trait; start with unlinked */
   if (NVary)
      for (sx = FEM; sx <= MAL; sx++)
         set_chromosomes (NMarks, Marek[sx], nh, trtloc0, trtrec0, sx);
   /* Autozyg programs have linked or unlinked trait */
   else
      for (sx = FEM; sx <= MAL; sx++)
         set_chromosomes (NMarks, Marek[sx], 0, &Loc0, &Rec0[sx], sx);

   return;
}

/**
 *  flag marker loci specified as trait; set up trait structures.
 */
void setLocTyp (void)
{
   int  *loc_flags;
   int   ntraits, nmarkers;

   loc_flags = malloc ((NMarks + 1) * sizeof (int));
   alloc_chk (WHERE, loc_flags);

   /* set up trait structures, one for each locus FIXME:  type of locus  
    *                                          struct Trait traits[NMarks+1] */
   ntraits = set_traits (NMarks, loc_flags);
   nmarkers = print_traits (ntraits, loc_flags);

   if (loc_flags)
   {
      free (loc_flags);
      loc_flags = NULL;
   }
   return;
}
