/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

#include "nghds.h"

/*
 * Recursive program which returns the kinship coefficient between
 * individuals a and b. 
 */

extern double inbreeding (Ind *);

double kinship (Ind * a, Ind * b)
{
   if (isNullNode (a) || isNullNode (b))
      return 0.0;

   if (a == b)
      return 0.5 + 0.5 * inbreeding (a);
   else if (isNullNode (a->pa))
   {
      if (b->index < a->index)
         return 0.0;
      else if (isNullNode (b->pa))
         return 0.0;
      else
         return (kinship (a, b->pa) + kinship (a, b->ma)) * 0.5;
   }
   else if (isNullNode (b->pa))
   {
      if (a->index < b->index)
         return 0.0;
      else
         return (kinship (b, a->pa) + kinship (b, a->ma)) * 0.5;
   }
   else if (a->index < b->index)
      return (kinship (a, b->pa) + kinship (a, b->ma)) * 0.5;
   else
      return (kinship (b, a->pa) + kinship (b, a->ma)) * 0.5;
}
