/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
#include "markers.h"

void dbgXXGG (void)
{
   int   i, j;

   for (j = 0; j < NMarks + 1; ++j)
   {
      fprintf (stderr, "Locus %d position %d set-up\n", j, chromo[0][j]);
      for (i = 0; i < PedSize; ++i)
      {
         fprintf (stderr, " %3d %*s", i, widPNam, nghd[i].self);
         fprintf (stderr, "  %*s  %*s", widPNam, nghd[i].pa->self,
                  widPNam, nghd[i].ma->self);
         fprintf (stderr, "   %2d  %2d   %2d  %2d\n",
                  xx1[j][i], xx0[j][i], gg1[j][i], gg0[j][i]);
      }
      fprintf (stderr, "\n");
      fflush (stderr);
   }
   return;
}

void dbgGDatGG (int j)
{
   int   i, ii;

   for (i = 0; i < NObs; ++i)
   {
      ii = ObsIx[i];
      fprintf (stderr, "   %2d %*s %2d   %2d %2d   %2d %2d",
               i, widPNam, nghd[ii].self, ii, gg1[j][ii], gg0[j][ii],
               nghd[ii].g_dat[2 * j], nghd[ii].g_dat[2 * j + 1]);
   }
   fprintf (stderr, "\n");
   fflush (stderr);
   return;
}
void dbgProb (double **p)
{
   int   j, c;

   for (j = 0; j < NMarks + 1; ++j)
   {
      fprintf (stderr, " Set genes at locus %d:\n", j);
      dbgGDatGG (j);
   }
   for (j = 0; j < NMarks + 1; ++j)
   {
      fprintf (stderr, " Scored prob at locus %d; giving", j);
      fflush (stderr);
      for (c = 0; c < nCompnt; ++c)
         fprintf (stderr, "   Component %d:  %7.4f\n", c, p[c][j]);
   }
   fprintf (stderr, "\n");
   fflush (stderr);
   return;
}
