/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/* do_msmpl(), alloc_msmpl(), free_msmpl()  */

/*******************************************************************
*    M-Sample Step     EAT 1997                                    *
*      to subroutine   EAT March 2000                              *
*    Note the trait-locus is included in sampling, even when not   *
*      used as in lm_markers, or (as of 10/2004) lm_pval           *
*    This is inefficient, but not incorrect-- and not easy to fix  *
*      in general, since indexing is by position not locus label   *
********************************************************************/
#include "msample.h"

static int *new_segs;                   /* [NLOC]     */
static double **pp2;                    /* [NLOC][2]  penetrance probabilities 
                                           at each locus under proposed values 
                                           for switching given meiosis in given 
                                           component                          */
static double **pcf;                    /* [NLOC][2]  cumulative peeling probs 
                                           along chromosome                   */

void do_msmpl (int nl, int mm, int c, int i, int sx, double **prob, int ng)
/* if mm=1, do not do locus 0 if chromo[0][0]==0  */
{
   int   j, jj, err, mmm;
   int   xx = 0, **xxx;
   double rr;

   mmm = mm;
   if (chromo[0][0] != 0)
      mmm = 0;

/*   mmm=0;     */

   if (sx == 0)
      xxx = xx0;
   else
      xxx = xx1;

   /* store current penetrance values in pp2,
      make switches, and store new penetrance values */
   for (jj = mmm; jj <= nl; ++jj)
   {
      pp2[jj][xxx[jj][i]] = prob[c][jj];
      xxx[jj][i] = 1 - xxx[jj][i];

      gene_update (jj, i, sx);
      pp2[jj][xxx[jj][i]] = seg_pen2 (c, Qq[jj], jj, ng, &err);
      prob[c][jj] = pp2[jj][xxx[jj][i]];
   }
   /* compute P(S_j | Y_1, ..., Y_j) by "peeling" */
   for (j = mmm; j <= nl; ++j)
   {
      jj = chromo[0][j];
      rr = xecomo[sx][0][j - 1];
      fwd_compute (j, mmm, rr, pp2[jj], pcf[j - 1], pcf[j]);
   }
   /* sample new indicators by "reverse peeling" */

   for (j = nl; j >= mmm; --j)
   {
      rr = xecomo[sx][0][j];
      xx = back_sample (nl, j, xx, rr, pcf[j][0]);
      new_segs[j] = xx;
   }

   for (j = nl; j >= mmm; --j)
   {
      xx = new_segs[j];

      jj = chromo[0][j];
      if (xx != xxx[jj][i])
      {
         xxx[jj][i] = xx;
         gene_update (jj, i, sx);
         prob[c][jj] = seg_pen2 (c, Qq[jj], jj, ng, &err);
      }
   }
   return;
}

void alloc_msmpl (void)
{
   ali_nl (&new_segs);
   ald_nl_n (&pp2, 2);
   ald_nl_n (&pcf, 2);

   return;
}
void free_msmpl (void)
{
   if (!new_segs)
      return;
   fre_n ((void *) &new_segs);
   fre_nl_n ((void *) &pp2);
   fre_nl_n ((void *) &pcf);

   return;
}
